#include "Hook_Utility.h"

#ifdef __SASC

static APTR __saveds __asm Function_Hook(register __a0 struct Hook *hook,
								  register __a2 APTR		object,
								  register __a1 APTR		message)
{
	return(((proto_c_function)hook->h_SubEntry)(hook,object,message));
}

#else

static APTR __attribute__((saveds)) Function_Hook(void)
{
	register struct Hook *a0 __asm("a0");
	register APTR a2 __asm("a2");
	register APTR a1 __asm("a1");

	return ((proto_c_function)a0->h_SubEntry)(a0,a2,a1);
}

#endif /* __SASC */

void InstallHook(struct Hook *hook, proto_c_function c_function, APTR Data)
{
	struct MinNode null_node = {NULL,NULL};

	hook->h_MinNode = null_node;
	hook->h_Entry = (ULONG (*)()) Function_Hook;
	hook->h_SubEntry = (ULONG (*)())c_function;
	hook->h_Data = Data;
}